
package Album;

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.util.Vector;
/**
 * This class was generated by a SmartGuide.
 * 
 */
public class ImagePropertySet extends Share.FileHandler{
	public File dir;
/*
	public long length[];
	public String names_org[];
	public String names[];
	public Dimension image_dims[];
	public Dimension thumbnail_dims[];
	protected ExifProperty exif[];
*/
protected ImageProperty properties[];

/**
 * This method was created by a SmartGuide.
 * @param dir java.io.File
 */
public ImagePropertySet (File d,  String image_suffix, String thumbnail_suffix, String thumbnail_dir, boolean case_sensitive, boolean make_thumbnail) {
	if(d.isDirectory())
		dir = d;
	else
		dir = new File(d.getParent());
SuffixFilter filter = new SuffixFilter(image_suffix, case_sensitive);
String names_org[] = getSortedDirectoryList(dir, filter);
int num = names_org.length;
	properties = new ImageProperty[num];
	for(int i=0 ; i<num ; i++){
	String name = trimSuffix(names_org[i],image_suffix);
	String tnname = name + thumbnail_suffix;
		if(make_thumbnail){
		File tndir = new File(dir, thumbnail_dir);
			if(!tndir.exists())
				tndir.mkdir();
			if(tndir.isDirectory())
				properties[i] = new ImageProperty(dir, name , names_org[i], tnname, thumbnail_dir, true);
			else
				properties[i] = new ImageProperty(dir, name , names_org[i], tnname, thumbnail_dir, false);
		}else
			properties[i] = new ImageProperty(dir, name , names_org[i], tnname, thumbnail_dir, false);
	}

	Vector pbuf = new Vector();
	for(int i=0 ; i<num ; i++){
		Dimension dim = properties[i].getDimension();
		if(dim.getWidth() > 0 || dim.getWidth() > 0)
			pbuf.addElement(properties[i]);
	}

	num = pbuf.size();
	properties = new ImageProperty[num];
	pbuf.copyInto(properties);

	return;
}
/**
 * This method was created by a SmartGuide.
 * @return java.io.File
 */
public File getDir() {
	return dir;
}
/**
 * This method was created by a SmartGuide.
 * @return java.lang.String
 * @param suffix java.lang.String
 */
public File getFile(int number, String suffix) {
	return new File(dir, properties[number].getName()+suffix);
}
/**
 * This method was created by a SmartGuide.
 * @return Album.ImageProperty
 * @param number int
 */
public ImageProperty getImageProperty(int number) {
	if(number < properties.length)
		return properties[number];
	return null;
}
/**
 * This method was created by a SmartGuide.
 * @return int
 */
public int getLength() {
	if(properties != null)
		return properties.length;
	return 0;
}
public String trimSuffix(String filename, String suffix) {
	return filename.substring(0,filename.length()-suffix.length());
}
}